%define apxs    %{_sbindir}/apxs
%define aprconf %{_bindir}/apr-config
%define apuconf %{_bindir}/apu-config
%define libtool %(lt=$(%{apxs} -q LIBTOOL) ; if test -z "$lt" ; then lt=%{_sysconfdir}/httpd/build/libtool ; fi ; echo $lt)
%define aplibdir    %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define apincdir    %(inc=$(%{aprconf} --includedir 2>/dev/null) ; if test -z "$inc" ; then inc=$(%{apxs} -q INCLUDEDIR 2>/dev/null) ; fi ; echo $inc)
%define aprlibs     %(libs=$(%{aprconf} --link-ld --libs 2>/dev/null) ; if test -z "$libs" ; then libs="-lapr" ; fi ; echo $libs)
%define apulibs     %(libs=$(%{apuconf} --link-ld --libs 2>/dev/null) ; echo $libs)
%define aplogdir    %{_localstatedir}/log/httpd
%define aprundir    %{_localstatedir}/run
%define section     free
%define epoch      1 

Summary:        Tomcat mod_jk2 connector for Apache 2.0.x
Name:           mod_jk2
Version:        2.0.4
Release:        4jpp_4rh
Epoch:          %{epoch}
#Vendor:         JPackage Project
#Distribution:   JPackage
License:        Apache Software License
Group:          Internet/WWW/Servers
ExclusiveArch:  i386 ia64 ppc
URL:            http://jakarta.apache.org/tomcat/
Source0:        http://www.apache.org/dist/jakarta/tomcat-4/v4.1.29/src/jakarta-tomcat-connectors-4.1.29-src.tar.gz
Source1:        workers2.properties.sample
Source2:        mod_jk2.conf.sample
Source3:        filter-depends.sh

%define __perl_requires %{SOURCE3}

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  libtool, %{apxs}, %{_bindir}/perl, jpackage-utils >= 0:1.5
BuildRequires: %{_bindir}/pcre-config
Provides:       mod_jk2-ap20 = %{epoch}:%{version}-%{release}
Obsoletes:      tomcat-mod

%description
Tomcat 4.x mod_jk2 connector for Apache 2.0.x.

You can use the following rpm build flags to customize executable locations,
but usually that should not be necessary:
* apxs:       "--define 'apxs /path/to/your/apxs'"
* apr-config: "--define 'aprconf /path/to/your/apr-config'"
* apu-config: "--define 'apuconf /path/to/your/apu-config'"
* libtool:    "--define 'libtool /path/to/your/httpd/libtool'"

%package        tools
Summary:        Analysis and report tools for mod_jk2
Group:          Internet/Log Analysis

%description    tools
Miscellaneous mod_jk2 analysis and report tools.


%prep
%setup -q -n jakarta-tomcat-connectors-4.1.29-src
perl -pi -e 's|/usr/local/bin\b|%{_bindir}|' jk/tools/reports/*.pl
perl -pi -e 's|-lapr-0\b|%{aprlibs} %{apulibs}|' \
  jk/native2/server/apache2/Makefile.in
install -p -m 0644 %{SOURCE1} %{SOURCE2} .
perl -pi -e \
  's|\@logdir\@|%{aplogdir}| ;
   s|\@rundir\@|%{aprundir}|' \
  workers2.properties.sample


%build

cd jk/native2

[ -x ./configure ] || sh ./buildconf.sh
%{?!_without_pcre:CFLAGS="$RPM_OPT_FLAGS `pcre-config --cflags`"} %configure \
  --with-apxs2=%{apxs} \
  --with-java-home=%{java_home} \
  --with-java-platform=2 \
  --with-jni \
  --with-apr-include=%{apincdir} \
%{!?_without_pcre:  --with-pcre}

make %{?_smp_mflags} LIBTOOL="%{libtool}"

cd ../..


%install
rm -rf $RPM_BUILD_ROOT
install -dm 0755 $RPM_BUILD_ROOT%{aplibdir}
install -pm 0755 jk/build/jk2/apache2/*.so $RPM_BUILD_ROOT%{aplibdir}
install -dm 0755 $RPM_BUILD_ROOT%{_bindir}
install -pm 0755 jk/tools/reports/tomcat_*.pl $RPM_BUILD_ROOT%{_bindir}


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc LICENSE jk/native2/*.html jk/native2/*.txt *.sample
%{aplibdir}/*.so

%files tools
%defattr(-,root,root,-)
%doc jk/tools/reports/README.txt
%{_bindir}/tomcat_*.pl


%changelog
* Fri Jul 23 2004 Fernando Nasser <fnasser@redhat.com> - 1:2.0.4-4jpp_4rh
- Add more architectures (ia64, ppc, ppc64)

* Tue Jul 06 2004 Andrew Overholt <overholt@redhat.com> - 1:2.0.4-4jpp_3rh
- Add script to filter out undesired perl requirements
  (courtesy Chip Turner <chip@redhat.com>)

* Tue Mar 16 2004 Frank Ch. Eigler <fche@redhat.com> - 1:2.0.4-4jpp_2rh
- Epoch: 1

* Mon Mar 15 2004 Frank Ch. Eigler <fche@redhat.com> - 0:2.0.4-4jpp_1rh
- RH vacuuming

* Mon Jan 12 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-4jpp
- Use apu-config if available for apache2 to make JNI work.
- Improve /jkstatus config in included sample configuration files.

* Sat Nov 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-3jpp
- Use apr-config if available for apache2 to allow building on FC1.
- Use upstream TC 4.1.29 connectors tarball.

* Thu Jul 24 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-2jpp
- Remove spurious mod_jk1 Jk* directives from the sample config file.
- Cosmetic spec file tweaks.

* Fri Jun 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-1jpp
- Add missing e:v-r to mod_jk2-ap20 Provides.
- First public JPackage release.

* Thu Jun 26 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-0.2jpp
- Include sample config.

* Wed Jun 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-0.1jpp
- Made apxs customizable with
  "rpmbuild --rebuild --define 'apxs /path/to/your/apxs'".

* Wed Jun 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.4-0jpp
- First build.
